% alap4(KX, KY, Kif):
% Kif az KX s KY kifejezsekbl a ngy alapmvelet egyikvel ll el.
alap4(KX, KY, KX+KY).
alap4(KX, KY, KX-KY).
alap4(KX, KY, KX*KY).
alap4(KX, KY, KX/KY).


% kif(K): K a ngy alapmvelettel szmokbl kpzett kifejezs.
kif(K) :- number(K).
kif(K) :-
	alap4(X, Y, K),
	kif(X),
	kif(Y).


% kif_levelek(+Kif, ?L): A Kif kifejezs leveleiben lev
% szmok listja  L.
kif_levelek(Kif, L) :-
	L = [Kif], number(Kif).
kif_levelek(Kif, L) :-
	alap4(K1, K2, Kif),
	kif_levelek(K1, L1),
	kif_levelek(K2, L2),
	append(L1, L2, L).

