:- use_module(library(lists), [permutation/2]).

kif(SzamL, MuvL, E, Kif) :-   % Az adott SzamL szmlistbl
                              % az adott MuvL listabeli mveletekkel
                              % felpthet a K kifejezs
                              % amelynek rtke az adott Ertek, ha
    permutation(SzamL, PL),   %     SzamL egy permutcija PL s
    kif1(PL, MuvL, Kif),      %     a PL levllistbl a MuvL mveletekkel
                              %       felpthet a Kif kifejezs s
    catch(Kif =:= E, _, fail).%     Kif szmrtke Ertek.

% kif1(L, MuvL, Kif):         
kif1([Kif], _, Kif).          % Az egyelemu [Kif] listbl Kif pthet fel.
kif1(L, MuvL, Kif) :-         % L-bl a MuvL mveletekkel felpthet Kif ha
    append(L1, L2, L),        % L elll mint L1 s L2 sszefzse ahol
    L1 \= [], L2 \= [],       % L1 nem res s L2 nem res, s
    kif1(L1, MuvL, K1),       % L1-bl a MuvL mveletekkel felpthet K1, s
    kif1(L2, MuvL, K2),       % L2-bl a MuvL mveletekkel felpthet K2, s
    member(M, MuvL),          % M egy MuvL listbeli mvelet, s
    Kif =.. [M,K1,K2].        % Kif egy az M mvelettel a K1-bl s K2-bl 
                              % felpl ktargumentum kifejezs.
